<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesResultProxy extends \Entities\Result implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function id()
    {
        $this->__load();
        return parent::id();
    }

    public function student(\Entities\Student $student = NULL)
    {
        $this->__load();
        return parent::student($student);
    }

    public function teacher(\Entities\Teacher $teacher = NULL)
    {
        $this->__load();
        return parent::teacher($teacher);
    }

    public function part(\Entities\Part $part = NULL)
    {
        $this->__load();
        return parent::part($part);
    }

    public function column($column = NULL)
    {
        $this->__load();
        return parent::column($column);
    }

    public function value($value = NULL)
    {
        $this->__load();
        return parent::value($value);
    }

    public function note($note = NULL)
    {
        $this->__load();
        return parent::note($note);
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'id', 'student_login', 'student', 'teacher_login', 'teacher', 'part', 'column', 'value', 'note');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}